/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is WebMail Notifier.
 *
 * The Initial Developer of the Original Code is
 * Byungwook Kang.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

const dout=Components.utils.reportError;

function wmn_ui() {
  this.mailInfo=[];
}

wmn_ui.prototype.openTab=function(url,name) {
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
           .getService(Components.interfaces.nsIWindowMediator);
  var enm = wm.getEnumerator("navigator:browser");
  while(enm.hasMoreElements()){
    var browser = enm.getNext().getBrowser();
    for (var i = 0;i< browser.mTabContainer.childNodes.length;i++){
      var tab = browser.mTabContainer.childNodes[i];
      if (tab.hasAttribute("tabname")&&tab.getAttribute("tabname")==name) {
        browser.getBrowserForTab(tab).loadURIWithFlags(url);
        //browser.selectedTab = tab;
        browser.contentWindow.focus();
        return;
      }
    }
  }
  //not found
  var tab = getBrowser().selectedTab;
  if(getBrowser().getBrowserForTab(tab).currentURI.spec=="about:blank"
    &&!tab.hasAttribute("tabname")){
    getBrowser().getBrowserForTab(tab).loadURIWithFlags(url);
  }else{
    tab=getBrowser().addTab(url)
  }
  tab.setAttribute("tabname",name);
}
wmn_ui.prototype.openWindow=function(url,name) {
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
           .getService(Components.interfaces.nsIWindowMediator);
  var enm = wm.getEnumerator("navigator:browser");
  while(enm.hasMoreElements()){
    var browser=enm.getNext().getBrowser();
    var win = browser.contentWindow;
    if(win.name==name){
      browser.loadURIWithFlags(url);
      win.focus();
      return;
    }
  }
  //not found
  window.open(url,name);
}
wmn_ui.prototype.onClick = function(aEvent) {
  // on windows, right click calls this method
  if (aEvent && (aEvent.button == 2))
    return;
  var openInTab=this.checkOpenType();
  if(this.mailInfo.length==1){
    this._openMail(this.mailInfo[0].host,this.mailInfo[0].user,openInTab);
    return;
  }
  var openAll=aEvent && (aEvent.button == 1||aEvent.shiftKey);
  for each(var o in this.mailInfo){
    if((o.mailCount>0||openAll)&&this.nsIWebMailNotifier.isDefault(o.host,o.user)){
      this._openMail(o.host,o.user,openInTab);
    }
  }
}
wmn_ui.prototype.onCheckNow = function() {
  gWMN_UI.nsIWebMailNotifier.checkMails();
}
wmn_ui.prototype.onPreferences = function() {
  var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                              .getService(Components.interfaces.nsIPrefService);
  var branch = prefService.getBranch("browser.preferences.");
  branch.QueryInterface(Components.interfaces.nsIPrefBranch2);
  var instantApply= branch.getBoolPref("instantApply");
  var features = "chrome,titlebar,toolbar,centerscreen" + (instantApply ? ",dialog=no" : ",modal");
  window.openDialog("chrome://wm-notifier/content/wmn-pref.xul","wmn-pref",features).focus();
  //window.openDialog("chrome://wm-notifier/content/test/preferences.xul","wmn-pref",features).focus();
}
wmn_ui.prototype.checkOpenType=function(){
  return this._getBoolPref("openInTab");
}
wmn_ui.prototype._getBoolPref=function(name){
  var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                              .getService(Components.interfaces.nsIPrefService);
  var branch = prefService.getBranch("wm-notifier.");
  branch.QueryInterface(Components.interfaces.nsIPrefBranch2);
  return branch.getBoolPref(name);
}
wmn_ui.prototype._openMail=function(id,user,openInTab){
  if(openInTab){
    this.openTab(gWMN_UI.nsIWebMailNotifier.getMailURL(id,user),"webmail"+id);
  }else this.openWindow(gWMN_UI.nsIWebMailNotifier.getMailURL(id,user),"webmail"+id);
}
wmn_ui.prototype.openMail = function(id,user) {
  this._openMail(id,user,this.checkOpenType());
}
wmn_ui.prototype.getHostName = function(host) {
  var s="webmail"+host;
  try{
    return this.getString(s);
  }catch(e){}
  var t=gWMN_UI.nsIWebMailNotifier.getHostName(host);
  return t?t:s;
}
wmn_ui.prototype.getString = function(aName) {
  var strbundle = document.getElementById("wmn-stringbundle");
  return strbundle.getString(aName);
}
wmn_ui.prototype.getAccountName = function(aID,aUser) {
//  if(this.nsIWebMailNotifier.isDefault(aID,aUser)){
//  if(!this.isMulti){
  if(this.nsIWebMailNotifier.isMultiple(aID)){
    return this.getHostName(aID)+" ["+aUser+"]";
  }else{
    return this.getHostName(aID);
  }
}

/***********************************************************
WebMailListener implementation
***********************************************************/
wmn_ui.prototype.onStateChange = function(aID,aUser,aCount){
  document.getElementById("wmn-context-menu").collapsed=true;
  if(aID==Components.interfaces.nsIWebMailNotifier.ST_RESET){//accounts change
    this.initCount();
  }
  for(var i in this.mailInfo){
    var o=this.mailInfo[i];
    if(o.host==aID&&o.user==aUser){
      o.mailCount=aCount;
      var menu=document.getElementById("wmn-context-menu").childNodes[i];
//      menu.setAttribute("image",aCount>0?"chrome://wm-notifier/content/mail-new.png":"");
      menu.setAttribute("style","font-weight:"+(aCount>0?"bold":"normal"));
      break;
    }
  }
  if(!document||!document.getElementById("wm-notifier-statusbar"))return;
  //clear tooltip message
  var msgbox=document.getElementById("wmn-tooltip-text");
  while(msgbox.firstChild != null)msgbox.removeChild(msgbox.firstChild);

  var total=0;
  for each(var o in this.mailInfo){
    if(o.mailCount>0){
      total+=o.mailCount;
      var desc = document.createElement("description");
      desc.setAttribute("value",o.name+" : "+o.mailCount);
      desc.setAttribute("style","color: green;");
      msgbox.appendChild(desc);
    }
  }
  if(total==0){
      var desc = document.createElement("description");
      desc.setAttribute("value",this.getString("NoNewMail"));
      desc.setAttribute("style","color: grey;");
      msgbox.appendChild(desc);
  }
  for each(var o in this.mailInfo){
    if(o.mailCount<0){
      var desc = document.createElement("description");
      desc.setAttribute("value",o.name+" : "+this.getString("NotChecked"));
      desc.setAttribute("style","color: red;");
      msgbox.appendChild(desc);
    }
  }
  document.getElementById("wm-notifier-statusbar").setAttribute("newMail", total>0);
  document.getElementById("wm-notifier-statusbar").setAttribute("label",total>0?total:"");
  document.getElementById("wmn-context-menu").collapsed=false;
}

wmn_ui.prototype.openYahooDialog = function(user,arg) {
  var params = {inn:{user:user,secdata:arg}, out:null};
  var features = "chrome,titlebar,toolbar,centerscreen,modal";
  window.openDialog("chrome://wm-notifier/content/yahoologin.xul","",features,params).focus();
  if (params.out)return params.out.secword;
  else return null;
}
wmn_ui.prototype.showAlertNotification = function(total){
  window.openDialog("chrome://wm-notifier/content/alert.xul","_blank",
      "chrome,dialog=yes,titlebar=no,popup=yes",
      this.mailInfo,this).focus();
}
/**********************************************************/

wmn_ui.prototype.initCount = function() {
    var menu=document.getElementById("wmn-context-menu");
    var sep=document.getElementById("wmn-menu-sep");

    for(var i = 0; i < this.mailInfo.length; i++)menu.removeChild(menu.firstChild);
    var s0=gWMN_UI.getString("open0");
    if(s0)s0=s0+" ";
    var s1=gWMN_UI.getString("open1");
    if(s1)s1=" "+s1;
    var n=this.nsIWebMailNotifier.getAccountsNumber();
    this.mailInfo=[];
    //this.isMulti=false;
    for(var i=0;i<n;i++){
      if(!this.nsIWebMailNotifier.isAccountEnabled(i))continue;
      var ar=this.nsIWebMailNotifier.getAccountInfo(i).split("\t");
      var id=ar[0];
      var username=ar[1];
      this.mailInfo.push({host:id,user:username});
      //if(!this.nsIWebMailNotifier.isDefault(id,username))this.isMulti=true;
    }
    for each(var o in this.mailInfo){
      o.mailCount=0;
      o.name=this.getAccountName(o.host,o.user);
      var mi = document.createElement("menuitem");
      mi.setAttribute("label",s0+o.name+s1);
      mi.setAttribute("oncommand","gWMN_UI.openMail("+o.host+",\""+o.user+"\")");
//      mi.setAttribute("class","menuitem-iconic");
      menu.insertBefore(mi,sep);
    }
}
wmn_ui.prototype.onload = function() {
  if (document.getElementById("wm-notifier-statusbar")) {
    try {
      gWMN_UI.nsIWebMailNotifier = Components.classes["@mozilla.org/WebMailNotifier;1"]
                                                  .getService(Components.interfaces.nsIWebMailNotifier);
      gWMN_UI.initCount();
      gWMN_UI.nsIWebMailNotifier.addListener(gWMN_UI);
    } catch (e) {}
    window.removeEventListener("load", gWMN_UI.onload, false);
  }
}

wmn_ui.prototype.onunload = function() {
  if (document.getElementById("wm-notifier-statusbar")) {
    // remove the listener
    if (gWMN_UI.nsIWebMailNotifier)
      gWMN_UI.nsIWebMailNotifier.removeListener(gWMN_UI);
  }
  gWMN_UI = null;
}

var gWMN_UI = new wmn_ui();

window.addEventListener("load", gWMN_UI.onload, false);
window.addEventListener("unload", gWMN_UI.onunload, false);
